unit PairProgramAlone;

interface

procedure Register;

implementation

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, ToolsApi,
  Comctrls, ExtCtrls, Menus, Clipbrd, ActnMenus, ActnMan;

type
  TPairProgr = class
  public
    procedure ActivatePPClick (Sender: TObject);
    procedure OtherProgrammer (Sender: TObject);
  end;

var
  PairProMenuItem: TMenuItem = nil;
  Pair: TPairProgr = nil;
  fTimer: TTimer = nil;

procedure Register;
begin
  // create the new menu item
  PairProMenuItem := Menus.NewItem ('Pair Programming Alone',
    ShortCut (Word('P'), [ssShift, ssCtrl]), False,
    True, Pair.ActivatePPClick, 0, 'PairProMenuItem');
  (Application.MainForm.FindComponent ('ToolsMenu')
    as TMenuItem).Add (PairProMenuItem);
  fTimer := TTimer.Create (nil);
end;

{ TPairProgr }

procedure TPairProgr.ActivatePPClick(Sender: TObject);
begin
  ShowMessage ('Activating Pair Programming... Your Virtual Buddy Will Help You');
  fTimer.OnTimer := Pair.OtherProgrammer;
  fTimer.Interval := 5000;
  fTimer.Enabled := True;
end;

procedure TPairProgr.OtherProgrammer(Sender: TObject);
var
  iModule: IOTAModule;
  iSourceEditor: IOTASourceEditor;
  iView: IOTAEditView;
  iWriter: IOTAEditWriter;
  CurPos: TOTAEditPos;
  StartPos: Integer;
  CurCharPos: TOTACharPos;
  strCode: string;
begin
  if Clipboard.HasFormat(CF_TEXT) then
    strCode := Clipboard.AsText
  else
    strCode := 'btn := TButton.Create (nil); // here is an extra button';
  strCode := strCode + sLineBreak;

  iModule := (BorlandIDEServices as IOTAModuleServices).CurrentModule;
  if iModule = nil then
    raise Exception.Create ('File is closed...');

  if not Supports (iModule.CurrentEditor, IOTASourceEditor, iSourceEditor) then
    raise Exception.Create ('No editor found');

  iView := iSourceEditor.GetEditView (0);
  CurPos := iView.CursorPos;
  iView.ConvertPos(True, CurPos, CurCharPos);
  StartPos := iView.CharPosToPos(CurCharPos);

  iWriter := iSourceEditor.CreateUndoableWriter;
  iWriter.CopyTo (StartPos);
  iWriter.Insert(PChar(strCode));
end;

initialization

finalization
  fTimer.Free;
  PairProMenuItem.Free;

end.
