unit Pe_Caption;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DesignEditors, DesignIntf;

type
  TNewButton = class (TButton);

type
  TCaptionProperty = class (TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

procedure Register;

implementation

function TCaptionProperty.GetAttributes:
  TPropertyAttributes;
begin
  // drop down only
  Result := [paReadOnly, paMultiSelect, paValueList, paSortList];
end;

procedure TCaptionProperty.GetValues(Proc: TGetStrProc);
begin
  // provide a list of system sounds
  Proc ('OK');
  Proc ('Cancel');
  Proc ('&Load...');
  Proc ('&Save...');
  Proc ('&Open...');
  Proc ('&Close');
  Proc ('&Press');
  Proc ('Button&1');
  Proc ('New Caption');
end;

procedure Register;
begin
  RegisterComponents ('FunSide', [TNewButton]);
  RegisterPropertyEditor (TypeInfo(TCaption),
    TNewButton, 'Caption', TCaptionProperty);
end;

end.
