unit MultiHintButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMhButton = class(TButton)
  private
    FHints: TStringList;
    fCurHint: Integer;
    procedure SetHints(const Value: TStringList);
  protected
    procedure Enter (var Msg: TMessage); message cm_MouseEnter;
    procedure Leave (var Msg: TMessage); message cm_MouseLeave;
  public
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Hints: TStringList read FHints write SetHints;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('CodeRageFun', [TMhButton]);
end;

{ TMhButton }

constructor TMhButton.Create(AOwner: TComponent);
begin
  inherited Create (AOwner);
  FHints := TStringList.Create;
  fCurHint := 0;
  if fHints.Count > 0 then
    Hint := fHints [0];
end;

destructor TMhButton.Destroy;
begin
  inherited;
  fHints.Free;
end;

procedure TMhButton.Enter(var Msg: TMessage);
begin
  Inc (fCurHint);
  if fCurHint >= fHints.Count then
    fCurHInt := 0;
  if fHints.Count > 0 then
    Hint := fHints [fCurHint];
end;

procedure TMhButton.Leave(var Msg: TMessage);
begin
  inherited;
end;

procedure TMhButton.SetHints(const Value: TStringList);
begin
  FHints.Assign (Value);
end;

end.
