unit CrashForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ButtonWindows: TButton;
    ButtonComp: TButton;
    ButtonPens: TButton;
    ButtonMemory: TButton;
    ButtonStack: TButton;
    ButtonNil: TButton;
    ButtonString: TButton;
    Label1: TLabel;
    procedure ButtonWindowsClick(Sender: TObject);
    procedure ButtonCompClick(Sender: TObject);
    procedure ButtonPensClick(Sender: TObject);
    procedure ButtonMemoryClick(Sender: TObject);
    procedure ButtonStackClick(Sender: TObject);
    procedure ButtonNilClick(Sender: TObject);
    procedure ButtonStringClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ButtonWindowsClick(Sender: TObject);
var
  NewForm: TForm;
  Hwnd: THandle;
  I: Integer;
begin
  NewForm := TForm.Create (Application);
  NewForm.Show;
  NewForm.Update;

  // create a number of windows...
  try
    for I := 1 to 1000000 do
    begin
      Hwnd := CreateWindow ('button', 'Button',
        ws_child or ws_border or bs_pushbutton,
        I mod (ClientWidth - 40),
        I mod (ClientHeight - 20),
        40, 20,
        Handle, 0, HInstance, nil);
      if Hwnd = 0 then
        raise Exception.Create ('Out of handles');
      if (I mod 20) = 0 then
        NewForm.Caption := 'Created: ' +
          IntToStr (I);
      Application.ProcessMessages;
    end;
  finally
    ButtonWindows.Caption := Format ('Created: %d', [I]);
    NewForm.Free;
  end;
end;

procedure TForm1.ButtonCompClick(Sender: TObject);
var
  NewForm: TForm;
  Btn: TButton;
  I: Integer;
begin
  NewForm := TForm.Create (Application);
  NewForm.Show;
  NewForm.Update;

  // create a number of buttons...
  try
    for I := 1 to 1000000 do
    begin
      Btn := TButton.Create (NewForm);
      if (I mod 100) = 0 then
      begin
        Btn.Left := I mod (ClientWidth - 50);
        Btn.Top := I mod (ClientHeight - 20);
      end
      else
        Btn.Visible := False;
      Btn.Parent := NewForm;
      if (I mod 20) = 0 then
        NewForm.Caption := Format ('Created: %d', [I]);
      Application.ProcessMessages;
    end;
  finally
    ButtonComp.Caption :=
      'Created: ' + IntToStr (I);
    NewForm.Free;
  end;
end;

procedure TForm1.ButtonPensClick(Sender: TObject);
var
  H: THandle;
  I: Integer;
begin
  try
    for I := 1 to 1000000 do
    begin
      H := CreatePen (ps_solid, 1, RGB (0, 0, 0));
      if H = 0 then
        raise Exception.Create ('Out of handles');
      if (I mod 20) = 0 then
        ButtonPens.Caption := Format ('Created: %d', [I]);
      Application.ProcessMessages;
    end;
  finally
    ButtonPens.Caption := Format ('Created: %d', [I]);
  end;
end;

procedure TForm1.ButtonMemoryClick(Sender: TObject);
var
  H: THandle;
  I: Integer;
begin
  try
    for I := 1 to 1000000 do
    begin
      H := GlobalAlloc (ghnd, 1024);
      if H = 0 then
        raise Exception.Create ('Out of handles');
      if (I mod 20) = 0 then
        ButtonMemory.Caption := Format ('Created: %d', [I]);
      Application.ProcessMessages;
    end;
  finally
    ButtonMemory.Caption := Format ('Created: %d', [I]);
  end;
end;

function Add: Integer;
begin
  Add := Add + 1;
end;

procedure TForm1.ButtonStackClick(Sender: TObject);
begin
  ButtonStack.Caption := IntToStr (Add);
end;

procedure TForm1.ButtonNilClick(Sender: TObject);
begin
  CallWindowProc (nil, 0, 0, 0, 0);
end;

procedure TForm1.ButtonStringClick(Sender: TObject);
var
  s: string;
begin
  GetWindowText (Handle, PChar (s), Sizeof (s));
end;

end.
